local gradient
function love.load()
  local g = love.image.newImageData(20, 200)
  for y = 1, 100 do
    for x = 0, 19 do
      local a = 1
      if y < 50 then
        a = y/50
      end
      a = (a^4)*255
      g:setPixel(x, y, 0, 0, 0, a)
      g:setPixel(x, 100 - y + 100, 0, 0, 0, a)
    end
  end
  gradient = love.graphics.newImage(g)
  gradient:setFilter('linear', 'linear')
end

function love.draw()
  local mx, my = love.mouse.getPosition()
  love.graphics.clear(255, 255, 255, 255)
  local fq = 0.1
  for i = 1, 800, 20 do
    local a = i/800
    local r = math.sin(fq*32*a + 0) * 127 + 128
    local g = math.sin(fq*32*a + 2) * 127 + 128
    local b = math.sin(fq*32*a + 4) * 127 + 128
    love.graphics.setColor(r, g, b)
    local y = 0
    if mx >= i and mx < i + 20 then
      y = -10
    end
    love.graphics.draw(gradient, i, 200)
    love.graphics.rectangle("fill", i, 250 + y, 20, 100)
  end
end